
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:02:32 05/30/2006
-- Design Name:   HTR_SLB
-- Module Name:   tb.vhd
-- Project Name:  HTR_SLB_cpld
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: HTR_SLB
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY tb_vhd IS
END tb_vhd;

ARCHITECTURE behavior OF tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT HTR_SLB
	PORT(
		loc_add : IN std_logic_vector(6 downto 0);
		loc_rw : IN std_logic;
		loc_cs : IN std_logic;
		cclk_fb : IN std_logic;
		init_b : IN std_logic;
		done : IN std_logic;
		ctrl_in : IN std_logic_vector(2 downto 0);    
		loc_bus : INOUT std_logic_vector(7 downto 0);
		mdata : INOUT std_logic_vector(7 downto 0);
		cclk_fbp : INOUT std_logic;
		cclk : INOUT std_logic;      
		loc_add_out : OUT std_logic_vector(6 downto 0);
		maddr : OUT std_logic_vector(17 downto 0);
		moe_b : OUT std_logic;
		mce_b : OUT std_logic;
		mwe_b : OUT std_logic;
		prog_b : OUT std_logic;
		cs_b : OUT std_logic;
		spare5 : OUT std_logic;
		rdwr_b : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL loc_rw :  std_logic := '0';
	SIGNAL loc_cs :  std_logic := '1';
	SIGNAL cclk_fb :  std_logic := '0';
	SIGNAL init_b :  std_logic := '1';
	SIGNAL done :  std_logic := '1';
	SIGNAL loc_add :  std_logic_vector(6 downto 0) := "0100000";
	SIGNAL ctrl_in :  std_logic_vector(2 downto 0) := (others=>'1');

	--BiDirs
	SIGNAL loc_bus :  std_logic_vector(7 downto 0);
	SIGNAL mdata :  std_logic_vector(7 downto 0);
	SIGNAL cclk_fbp :  std_logic;
	SIGNAL cclk :  std_logic;

	--Outputs
	SIGNAL loc_add_out :  std_logic_vector(6 downto 0);
	SIGNAL maddr :  std_logic_vector(17 downto 0);
	SIGNAL moe_b :  std_logic;
	SIGNAL mce_b :  std_logic;
	SIGNAL mwe_b :  std_logic;
	SIGNAL prog_b :  std_logic;
	SIGNAL cs_b :  std_logic;
	SIGNAL spare5 :  std_logic;
	SIGNAL rdwr_b :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: HTR_SLB PORT MAP(
		loc_add => loc_add,
		loc_add_out => loc_add_out,
		loc_bus => loc_bus,
		loc_rw => loc_rw,
		loc_cs => loc_cs,
		maddr => maddr,
		mdata => mdata,
		moe_b => moe_b,
		mce_b => mce_b,
		mwe_b => mwe_b,
		cclk_fb => cclk_fb,
		cclk_fbp => cclk_fbp,
		cclk => cclk,
		prog_b => prog_b,
		cs_b => cs_b,
		spare5 => spare5,
		rdwr_b => rdwr_b,
		init_b => init_b,
		done => done,
		ctrl_in => ctrl_in
	);
loc_bus <= x"a5" when loc_rw = '0' else (others => 'Z');
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		loc_cs <= '0';
		wait for 400 ns;
		loc_cs <= '1';

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
