----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:35:55 06/01/2006 
-- Design Name: 
-- Module Name:    test_bufg - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity test_bufg is
    Port ( clk : inout  STD_LOGIC;
	        loc_mode : in std_logic;
	        clock : in std_logic;
           q : out  STD_LOGIC);
end test_bufg;

architecture Behavioral of test_bufg is
component
   bufg port(i : in std_logic; o : out std_logic);
end component;
component
   obuf port(i : in std_logic; o : out std_logic);
end component;
component
   buf port(i : in std_logic; o : out std_logic);
end component;
signal ring_os : std_logic_vector(3 downto 0);
signal clkb : std_logic;
signal c : std_logic;
signal d : std_logic;
attribute noreduce : string;
attribute noreduce of ring_os : signal is "true";
begin
i_g: for i in 1 to 3 generate
  i_buf: buf port map(i => ring_os(i-1), o => ring_os(i));
end generate;
ring_os(0) <= not clkb or loc_mode;
i_clk: obuf port map(i => ring_os(3), o => clk);
i_cfg_clk: bufg port map(i => clk, o => clkb);
q <= d;
process(clkb)
begin
  if(clkb'event and clkb = '1')then
    d <= not d;
  end if;
end process;
process(clock)
begin
  if(clock'event and clock = '1')then
    c <= not c;
  end if;
end process;

end Behavioral;

